<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:rutasxpath="xalan://es.uca.xmleye.xpath.GestorRutasXPath"
 xmlns:string="http://xml.apache.org/xalan/java/java.lang.String"
 xmlns:ppacl2="http://www.uca.es/xmleye/ppACL2-stylesheet">

<!-- MODO DE IMPRESIÓN DE INFORMACIÓN ESPECÍFICA A MÉTODO DE SUBMETA -->

<xsl:template match="subgoal[@method = 'simp']" mode="ppacl2_printsubgoal">
 <h2 class="method"><xsl:value-of select="$ppacl2:simplify"/></h2>
 <h3 class="subsection"><xsl:value-of select="$ppacl2:usedrules"/></h3>
 <xsl:apply-templates select="rules" mode="ppacl2_printnode"/>
</xsl:template>

<xsl:template match="subgoal[@method = 'elim']" mode="ppacl2_printsubgoal">
 <h2 class="method"><xsl:value-of select="$ppacl2:elimination"/></h2>

 <h3 class="section"><xsl:value-of select="$ppacl2:destruct_terms"/></h3>
 <ul>
   <xsl:for-each select="destruct_terms/destruct_term">
     <li><xsl:value-of select="@name"/></li>
   </xsl:for-each>
 </ul>

 <h3 class="section"><xsl:value-of select="$ppacl2:replacements"/></h3>
 <ul>
   <xsl:for-each select="replacements/replacement">
   <li><xsl:value-of select="concat(@from, ' -> ', @to)" /></li>
   </xsl:for-each>
 </ul>

 <h3 class="section"><xsl:value-of select="$ppacl2:rules"/></h3>
 <xsl:apply-templates select="rules" mode="ppacl2_printnode"/>
</xsl:template>

<xsl:template match="subgoal[@method='hypothesis']" mode="ppacl2_printsubgoal">
 <h2 class="method"><xsl:value-of select="$ppacl2:hypothesis"/></h2>

 <h3 class="section"><xsl:value-of select="$ppacl2:replacements"/></h3>
 <ul>
   <xsl:for-each select="replacements/replacement">
   <li><xsl:value-of select="concat(@from, ' -> ', @to)" /></li>
   </xsl:for-each>
 </ul>
</xsl:template>

<xsl:template match="subgoal[@method='crossfert']" mode="ppacl2_printsubgoal">
 <h2 class="method"><xsl:value-of select="$ppacl2:crossfert"/></h2>

 <h3 class="section"><xsl:value-of select="$ppacl2:replacements"/></h3>
 <ul>
   <xsl:for-each select="replacements/replacement">
   <li><xsl:value-of select="concat(@from, ' -> ', @to)" /></li>
   </xsl:for-each>
 </ul>
</xsl:template>

<xsl:template match="subgoal[@method='generalize']" mode="ppacl2_printsubgoal">
 <h2 class="method"><xsl:value-of select="$ppacl2:generalize"/></h2>

 <h3 class="section"><xsl:value-of select="$ppacl2:replacements"/></h3>
 <ul>
   <xsl:for-each select="replacements/replacement">
   <li><xsl:value-of select="concat(@from, ' -> ', @to)" /></li>
   </xsl:for-each>
 </ul>

 <xsl:apply-templates select="rules" mode="ppacl2_printnode"/>
</xsl:template>

<xsl:template match="subgoal[@method='discard']" mode="ppacl2_printsubgoal">
 <h2 class="method"><xsl:value-of select="$ppacl2:discard"/></h2>
 
 <h3 class="section"><xsl:value-of select="$ppacl2:irrelevantterm"/></h3>
 <pre><xsl:value-of select="@discarded"/></pre>
</xsl:template>

<xsl:template match="subgoal[@method='abandon']" mode="ppacl2_printsubgoal">
 <h2 class="method"><xsl:value-of select="$ppacl2:abandon"/></h2>
</xsl:template>

<xsl:template match="subgoal[@method='nottheorem']" mode="ppacl2_printsubgoal">
 <h2 class="method"><xsl:value-of select="$ppacl2:nottheorem"/></h2>
</xsl:template>

<xsl:template match="subgoal[@method='failure']" mode="ppacl2_printsubgoal">
 <h2 class="method" style="background-color: maroon"><xsl:value-of select="$ppacl2:failure"/></h2>
</xsl:template>

<xsl:template match="subgoal[@method='induction']" mode="ppacl2_printsubgoal">

  <h2 class="method"><xsl:value-of select="$ppacl2:induction"/></h2>

  <!-- Plan de inducción -->
  <h3 class="subsection"><xsl:value-of select="$ppacl2:inductionplan"/></h3>
  <xsl:choose>
    <xsl:when test="@plan">
      <pre><xsl:value-of select="@plan"/></pre>
    </xsl:when>
    <xsl:otherwise>
      <p class="info"><xsl:value-of select="$ppacl2:noinductplan"/></p>
    </xsl:otherwise>
  </xsl:choose>

  <!-- Sugerencias de inducción -->
  <xsl:apply-templates select="suggestions" mode="ppacl2_printnode"/>

</xsl:template>
<xsl:template match="*" mode="ppacl2_printsubgoal"/>

</xsl:stylesheet>